/**************************************************************************
*                Copyright notice for JavaHelp library                    *
*                                                                         *
*The present application links to JavaHelp library as an external jar file*
that is under the Sun Microsystems, Inc. Binary Code License Agreement and*
*supplemental license term fot JavaHelp version 2.0.                      *
*You can find a copy of that license at the root folder containing the    *
*main class of TESD. More informations are available at this web site:    *
*http://java.sun.com/products/javahelp                                    *
**************************************************************************/

/*************************************************************************
*         Copyright notice for JFreeChart and JCommon libraries          *
*                                                                        *
*The present application links to JFreeChart and JCommon libraries as    *
*external jar files that are under the GNU Lesser General Public License.*
*You can find a copy of that license at the root folder containing       *
*the main class of TESD. More informations such as complete source codes *
*to modify the libraries are available at this web site: www.jfree.org.  *
*************************************************************************/

import projet_these.et.*;
import projet_these.ig.*;
import javax.swing.*;




/**
 * The main class of TESD
 */
public class IslandModelTest
{

    /**
     * If -cmd argument is precised when launching TESD.jar in comand line,
     * the console menu of TESD is shown but not the graphical interface.
     * @param arguments The command line arguments when launching TESD
     */
    public static void main (String[] arguments)
    {

        // Le nom du logiciel
        String titre =
        "TESD, Transposable Elements Simulator Dynamics";

        // Le modele
        IslandModel IsMo = new Util_Islands();

        // L'interface graphique invisible au depart
        MainFrame fenetre;

        // Entree de l'utilisateur par defaut
        if (arguments.length == 0)
        {
            fenetre = new MainFrame(titre, true, IsMo);
            fenetre.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        }

        // Entree de l'utilisateur par terminal
        else if(arguments[0].equals("-cmd"))
        {
            fenetre = new MainFrame(titre, false, IsMo);
            do
            {
                ((Util_Islands) IsMo).consoleDOS(titre, fenetre);
            } while(true);
        }

        else
        {
            System.out.println(
                "This Program run without any parameters for initial users" +
                "\nor with -cmd for advanced users"
                );
        }
        
        try {
              UIManager.setLookAndFeel(
                  "ch.randelshofer.quaqua.QuaquaLookAndFeel"
              );
         // set UI manager properties here that affect Quaqua
         } catch (Exception e) {
             // take an appropriate action here
         }
 
    }

}

