package projet_these.et;

import java.util.*;



/**
 * Implementation of a pair of chromosomes under the agressive copies hypothesis
 * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
 * @version 01/03/02
 */
public class ChromoPairPoly extends ChromosomesPair
{

    /** 
     * Numbers of agressives insertions of the 2 pairs
     */
    protected int nb_agr;

    /** 
     * Numbers of agressives insertions of the a pair
     */
    private int nb_agr_a;


    /**
     * Empty Contructor of ChromoPairPoly
     */
    public ChromoPairPoly()
    {
    }


    /**
     * Constructor of initialization of chromosomes
     * @param n1 int
     * @param n2 int
     */
    public ChromoPairPoly(int n1, int n2)
    {
        super(n1);

        // Agressives copy number initiation on the pair
        nb_agr = n2;

        // Insterts positioning process & initiation of inserts number on a
        nb_agr_a = transpoIns(nb_agr, true);
    }


    /**
     * Procedure setting a pair of chromosomes after gametic fusion
     * @param i_a The a Chromosome
     * @param i_b The b Chromosome
     * @return ChromosomesPair
     */
    protected ChromosomesPair setChromo(Hashtable i_a, Hashtable i_b)
    {
        // Chromosomes in one pair
        inser_a = cloneChromo(i_a);
        inser_b = cloneChromo(i_b);

        // Insertions number initiation for a pair
        nb_ins_a = 0;
        nb_agr_a = 0;

        /* Variable de stockage d'un site d'insertion et nombre d'elements
        sur ce site*/
        LinkedList this_site;
        int this_site_size;

        // Puts chromosom a keys in a table
        Object[] keys = inser_a.keySet().toArray();

        // Insertion number determination on inser_a key after key
        for (int i = 0; i < keys.length; i++)
        {
            this_site = (LinkedList) inser_a.get((Byte) keys[i]);
            this_site_size = (this_site).size();
            for (int j = 0; j < this_site_size; j++)
            {
                if (! ((geneAllele)
                    ((LinkedList) inser_a.get((Byte) keys[i])).get(j))
                    .agressive) nb_ins_a++;
                else
                    nb_agr_a++;
            }
        }

        // Global insertion number determination on the pair
        nb_ins = nb_ins_a;
        nb_agr = nb_agr_a;
        keys = inser_b.keySet().toArray();
        for (int i = 0; i < keys.length; i++)
        {
            this_site = (LinkedList) inser_b.get((Byte) keys[i]);
            this_site_size = (this_site).size();
            for (int j = 0; j < this_site_size; j++)
            {
                if (! ((geneAllele)
                    ((LinkedList) inser_b.get((Byte) keys[i])).get(j))
                    .agressive) nb_ins++;
                else
                    nb_agr++;
            }
        }

        return (ChromosomesPair) this;
    }


    /**
     * Functin returning the total copy number
     * @return  Number of elements
     */
    protected int getCopNumber()
    {
        return (this.nb_ins + this.nb_agr);
    }


    /**
     * Functin returning the copy number on the "a" chromosome
     * @return  Number of elements on the "a"
     */
    protected int getCopNumber_a()
    {
        return (this.nb_ins_a + this.nb_agr_a);
    }
}