package projet_these.ig;

import projet_these.et.Population;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;
import javax.swing.JComponent;




/**
 * Extension of a general internal frame used
 * to ask the averages copies numbers
 * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
 * @version 10/12/02
 */
public class CopyNumbers extends SimpleQuestion {
    /**
     * The table
     */
    private myTable tablo;
    
    /**
     * Constructor of initialization of CopiesNumbers
     * @param super_frame The main frame
     */
    public CopyNumbers(MainFrame super_frame) {
        
        // Call of SimpleQuestion constructor
        super(super_frame, "Enter the TE copy number per population :");
        
        // Title & positionning
        setTitle("TE copy number per population");
        setup();
        
        // Copies table creation
        tablo = setTable();
        tablo.setToolTipText("Float values are accepted");
        
        // Closing managment by Ok activation
        B1.addActionListener(new ok_AL());
        
        // Closing managment by return activation
        B2.addActionListener(new return_AL());
    }
    
    /**
     * Procedure setting the table of populations copies numbers
     * @return The table
     */
    private myTable setTable() {
        
        // The datas
        Vector datas = new Vector();
        for (int i = 0; i < getsuperFrame().model.nb_pop; i++)
            datas.add(
                    (new Float(getsuperFrame().model.nbcop[i])).toString());
        for (int i = 0; i < getsuperFrame().model.nb_pop; i++)
            datas.add(i * 2, "Population " + (i + 1) + ":");
        
        // The names
        Vector names = new Vector();
        names.add("Populations");
        names.add("TE copy numbers");
        
        // The table & columns editions rights
        boolean[] rights = {false, true};
        myTable tablo = new myTable(datas, names, rights);
        
        // Centering of graphical components
        allCentered((JComponent) L1, (JComponent) tablo,
                (JComponent) panel1);
        
        return tablo;
    }
    
    
    /**
     * Procedure returning a reference to the curent
     * internal frame
     * @return the CopiesNumbers frame
     */
    private CopyNumbers getCopNumb() {
        
        return this;
    }
    
    
    /**
     * Implementation of the ActionListeneter interface
     * to listen to the events of the components
     * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
     * @version 01/03/02
     */
    private class ok_AL implements ActionListener {
        
        /**
         * Procedure setting the current model populations
         * copies numbers
         * @param  e   a click on the check box
         */
        public void actionPerformed(ActionEvent e) {
            tablo.uneditingRegularCells();
            
            for (int i = 0; i < getsuperFrame().model.nb_pop; i++) {
                if (util_IG.errorManager(getCopNumb(),
                        tablo.model.getValueAt(i, 1).toString(),
                        util_IG.POS_FLOAT))
                    return;
                getsuperFrame().model.nbcop[i] = Float.valueOf(
                        tablo.model.getValueAt(i, 1). toString()).
                        floatValue();
                
                // Instantiation of the copies number means table at initial time
                getsuperFrame().model.nbcop[i] = Float.valueOf(
                        tablo.model.getValueAt(i, 1). toString()).
                        floatValue();
                
                // Islands instantiation
                getsuperFrame().model.iles[i] =
                        new Population(getsuperFrame().model.N[i],
                        getsuperFrame().model.nbcop[i],
                        getsuperFrame().model.tps + 1);
            } // End of for
            
            // If homogeneous migrations, MigrationMatrix1 window openning
            if (getsuperFrame().model.rep_tx.equals("H")) {
                MigrationMatrix1 mm =
                        new MigrationMatrix1(getsuperFrame());
                getsuperFrame().desktop.add(mm);
                try {
                    mm.setSelected(true);
                } catch (java.beans.PropertyVetoException ve) {
                };
            }
            
            // Whereas (homogeneous migration) MigrationsMatrix2 openning
            else {
                MigrationMatrix2 mm =
                        new MigrationMatrix2(getsuperFrame());
                getsuperFrame().desktop.add(mm);
                try {
                    mm.setSelected(true);
                } catch (java.beans.PropertyVetoException ve) {
                };
            }
            
            // At that level, Islands creation procedure is finished
            if (getsuperFrame().entries != null)
                getsuperFrame().entries.upDate();
            dispose();
            return;
        }
    }
    
    
    /**
     * Implementation of the ActionListeneter interface
     * to listen to the events of the components
     * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
     * @version 01/03/02
     */
    private class return_AL implements ActionListener {
        
        
        /**
         * Procedure returning to the PopulationSizes frame
         * @param  e   a click on the Return button
         */
        public void actionPerformed(ActionEvent e) {
            // Re-openning of size entry window & closing of current window
            PopulationSizes ps = new PopulationSizes(
                    getsuperFrame());
            getsuperFrame().desktop.add(ps);
            try {
                ps.setSelected(true);
            } catch (java.beans.PropertyVetoException ve) {
            };
            dispose();
            return;
        }
    }
    
    
}


