package projet_these.ig;

import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import projet_these.es.InitIslanModelFromFile;

import javax.swing.*;



/**
 * Implementation of the FileDataEntry frame
 * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
 * @version 01/03/02
 */
public class FileDataEntry extends SimpleQuestion
{
    
    /**
     * Second label asking the output file name
     */
    private JLabel L2 = new JLabel("Ouput File name :");
    
    /**
     * TextField of seizure of the output file name
     */
    private JTextField T2 = new JTextField();
    
    
    /**
     * Constructor of initialization of FileDataEntry
     * @param super_frame The main frame
     */
    public FileDataEntry(MainFrame super_frame)
    {
        
        // Constructor call of SimpleQuestion
        super(super_frame, "Input File name :");
        
        // Title adding
        setTitle("File Data Entry");
        
        // panel1 is first removed to add L2 & T2
        getContentPane().remove(panel1);
        
        // Label L2 adding
        L2.setFont(L1.getFont());
        util_IG.addComposantContentPane(getContentPane(), L2,
                GridBagConstraints.EAST, 0, 1, 1, 1,
                new Insets(10, 0, 5, 10), 0, 0);
        
        // JTextField T2 adding
        util_IG.addComposantContentPane(getContentPane(), T2,
                GridBagConstraints.WEST, 1, 1, 1, 1,
                new Insets(10, 0, 5, 0), 150, 0);
        
        // Relese of Return button and panel1 positionment
        panel1.remove(B2);
        util_IG.addComposantContentPane(getContentPane(), panel1,
                GridBagConstraints.CENTER, 1, 2, 1, 1,
                new Insets(0, 0, 5, 0), 0, 0);
        
        // Window size adjustment
        setup();
        setSize(getSize().width, (int)(getSize().height * 1.5));
        
        // Closing management when ok is selected
        B1.addActionListener(new ActionListener()
        {
            
            // Error message
            String message = "";
            
            public void actionPerformed(ActionEvent e)
            {
                
                //If entry file name is not presised, a message error occurs
                if (T1.getText().equals(""))
                {
                    message = "Error of data entry\n" +
                            "Field: Input File name\n" +
                            "Enter a name";
                    JOptionPane.showMessageDialog(getsuperFrame(), message, "", 
                            JOptionPane.ERROR_MESSAGE);
                    return;
                }
                
                //If output file name is not presised, a message error occurs
                if (T2.getText().equals(""))
                {
                    message = "Error of data entry\n" +
                            "Field: Output File name\n" +
                            "Enter a name";
                    JOptionPane.showMessageDialog(getsuperFrame(), message, "", 
                            JOptionPane.ERROR_MESSAGE);
                    return;
                }
                
                //If entry file doesn't exist in the current directory, a message error occurs
                if (!(new File(T1.getText())).exists())
                {
                    message = "Error of data entry\n" +
                            "Field: Input File name\n" +
                            "File not found";
                    JOptionPane.showMessageDialog(getsuperFrame(), message, "", 
                            JOptionPane.ERROR_MESSAGE);
                    return;
                }
                
                //Otherwise output and input file names are uptaken & a model is initiated with 
                //output file parameters
                getsuperFrame().model.nomFic1 =
                        T1.getText();
                getsuperFrame().model.nomFic2 =
                        T2.getText();
                
                InitIslanModelFromFile.initModel(getsuperFrame().model);

                
                //Run item & Simulation menu are reactivated. Thus the window is closed
                getsuperFrame().item3.setEnabled(true);
                getsuperFrame().menu.setEnabled(true);
                dispose();
                
                // Entries are writen in the curent model's console
                getsuperFrame().setEntries();
                return;
            }
        }
        );
    }
}

