package projet_these.ig;

import projet_these.et.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;
import java.beans.*;




/**
 * Extension of a general internal frame used
 * to ask the number of migrants for heterogeneous case
 * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
 * @version 01/03/02
 */
public class MigrationMatrix2 extends JInternalFrame
{
    
    // Migrants matrix
    private JTextField[][] matrice;
    
    // Columns and lines index
    private JLabel[] lignes, colonnes;
    
    // Boutons de validation des entrees, OK et Cancel
    private JButton B1, B2, B3, B4;
    
    // Panneaux haut et bas
    private JPanel panH, panL;
    
    // Fenetre interne courante
    private MigrationMatrix2 moi;
    
    // Fenetre principale
    private MainFrame super_frame;
    
    
    /**
     * Constructor of initialization of MigrationMatrix2
     * @param super_frame The main frame
     */
    public MigrationMatrix2(MainFrame super_frame)
    {
        
        // JInternalFrame constructor call
        super("", false, true, false, false);
        
        /* Recuperation des references : sur la fenetre courante et
        sur la fenetre principale*/
        moi = this;
        setsuperFrame(super_frame);
        
        // Initialisation du titre de la fenetre
        setTitle("Migration Matrix Entry");
        
        // Gestion de la fermeture de la fenetre par la case cochee
        addInternalFrameListener(new intfram_Ad());
        
        // Creation du gestionnaire de fenetre
        getContentPane().setLayout(new BorderLayout());
        
        // Matrice de saisie des nombres de migrants
        matrice = new JTextField[getsuperFrame().model.nb_pop]
                [getsuperFrame().model.nb_pop];
        for (int i = 0; i < getsuperFrame().model.nb_pop; i++)
        {
            for (int j = 0; j < getsuperFrame().model.nb_pop; j++)
            {
                // Proposition de reponse
                if (getsuperFrame().model.tx_migration[0].length > 1)
                    getMatrice()[i][j] = new JTextField("" +
                            getsuperFrame().model.tx_migration[i][j]);
                else
                    getMatrice()[i][j] = (i != j) ?
                        new JTextField("" + 0): new JTextField("" +
                            getsuperFrame().model.N[i]);
            }
        }
        
        // Creation des labels des lignes et des colonnes
        lignes = new JLabel[getsuperFrame().model.nb_pop];
        colonnes = new JLabel[getsuperFrame().model.nb_pop + 2];
        
        // Creation du bouton Validate
        B1 = new JButton("Validate");
        B1.setPreferredSize(B1.getPreferredSize());
        B1.addActionListener(new AL());
        
        // Creation du bouton OK
        B2 = new JButton("OK");
        B2.setPreferredSize(B1.getPreferredSize());
        B2.addActionListener(new AL());
        
        // Creation du bouton Return
        B3 = new JButton("Return");
        B3.setPreferredSize(B3.getPreferredSize());
        B3.addActionListener(new return_AL());
        
        // Creation dsu bouton Cancel
        B4 = new JButton("Cancel");
        B4.setPreferredSize(B4.getPreferredSize());
        B4.addActionListener(new cancel_AL());
        B4.setFont(new Font("Dialog", Font.PLAIN, 12));
        
        // Construction de la fenetre avec deux panneaux superposes
        getContentPane().add(panH = new PanelHaut(), BorderLayout.CENTER);
        getContentPane().add(panL = new PanelBas(), BorderLayout.SOUTH);
        setSize(getLayout().preferredLayoutSize(this));
        setVisible(true);
        setLocation(10, 10);
    }
    
    
    /**
     * Access method to current instance of MigrationMatrix2
     */
    private MigrationMatrix2 getMigMat2()
    {
        return this;
    }
    
    
    /**
     * Access procedure to matrix
     */
    private JTextField[][] getMatrice()
    {
        return matrice;
    }
    
    
    /**
     * Access procedure to rows labels
     */
    private JLabel[] getLignes()
    {
        return lignes;
    }
    
    
    /**
     * Access procedure to hight panel
     */
    private JPanel getPanelHaut()
    {
        return panH;
    }
    
    
    /**
     * Access procedure to low panel
     */
    private JPanel getPanelBas()
    {
        return panL;
    }
    
    
    /**
     * Access procedure to columns labels
     */
    private JLabel[] getColonnes()
    {
        return colonnes;
    }
    
    
    /**
     * Access procedure to B1 button
     */
    private JButton getValidate()
    {
        return B1;
    }
    
    
    /**
     * Access procedure to B2 button
     */
    private JButton getOK()
    {
        return B2;
    }
    
    
    /**
     * Access procedure to B3 button
     */
    private JButton getAnnuler()
    {
        return B3;
    }
    
    
    /**
     * Procedure returning a reference to main frame
     * @return JFrame the TESD main frame
     */
    protected MainFrame getsuperFrame()
    {
        
        return super_frame;
    }
    
    
    /**
     * Procedure setting the reference to main frame
     * @param   sf  The main frame
     */
    protected void setsuperFrame(MainFrame sf)
    {
        
        super_frame = sf;
    }
    
    
    /**
     * Implementation of the ActionListeneter interface
     * to listen to the events of the components
     * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
     * @version 01/03/02
     */
    private class AL implements ActionListener
    {
        
        // Valeur d'un case de la matrice
        private float valeur;
        
        // Message d'erreur
        private String message = "";
        
        
        /**
         * Procedure carried out at the time of an event
         * @param e The event
         */
        public void actionPerformed(ActionEvent e)
        {
            // Initialisation des matrices : imigration, voisinage, tx_migration
            getsuperFrame().model.imigration =
                    new int[getsuperFrame().model.nb_pop]
                    [getsuperFrame().model.nb_pop - 1];
            getsuperFrame().model.voisinage =
                    new Population[getsuperFrame().model.nb_pop]
                    [getsuperFrame().model.nb_pop - 1];
            getsuperFrame().model.tx_migration =
                    new float[getsuperFrame().model.nb_pop]
                    [getsuperFrame().model.nb_pop];
            for (int i = 0; i < getsuperFrame().model.nb_pop; i++)
                getsuperFrame().model.tx_migration[i][i] =
                        getsuperFrame().model.N[i];
            
            // Parcours des cases de la matrice
            for (int i = 1; i < getsuperFrame().model.nb_pop; i++)
            {
                for (int j = 0; j < i; j++)
                {
                    
                    /* Signale une erreur lorsque la case courante ne contient
                    pas de nombre*/
                    if (! Util_Islands.isPositiveFloat(getMatrice()[i][j].getText()))
                    {
                        message = "Error of data entry\n" + "Field: " +
                                Integer.toString(i + 1) + "," +
                                Integer.toString(j + 1) + "\n" +
                                "The number of emigrants must be\n" +
                                "positive";
                        JOptionPane.showMessageDialog(getsuperFrame(), message, "", JOptionPane.ERROR_MESSAGE);
                        return;
                    }
                    
                    // Si la case est vide la valeur est consideree nulle
                    if (getMatrice()[i][j].getText().equals(""))
                    {
                        valeur = 0f;
                        getMatrice()[i][j].setText(String.valueOf(valeur));
                    }
                    
                    // Sinon on la recupere
                    else
                        valeur = Float.valueOf(
                                getMatrice()[i][j].getText()).floatValue();
                    
                    /* Si le nombre d'individus restants dans une des populations
                    est negatif, on signale une erreur*/
                    if (valeur > (Float.valueOf(
                            getMatrice()[i][i].getText()).floatValue() +
                            getsuperFrame().model.tx_migration[i][j]) ||
                            valeur > (Float.valueOf(
                            getMatrice()[j][j].getText()).floatValue() +
                            getsuperFrame().model.tx_migration[j][i]))
                    {
                        message = "Error of data entry\n" + "Field: " +
                                Integer.toString(i + 1) + "," +
                                Integer.toString(j + 1) + "\n" +
                                "The number of emigrants must be\n" +
                                "lower than the population\n" + "of origin size";
                        JOptionPane.showMessageDialog(getsuperFrame(), message, "", JOptionPane.ERROR_MESSAGE);
                        return;
                    }
                    
                    /* Sinon le nombre de migrants est saisis et le nombre
                     d'individus restants est reajuste*/
                    else
                    {
                        getsuperFrame().model.tx_migration[i][j] = valeur;
                        getsuperFrame().model.tx_migration[j][i] =
                                getsuperFrame().model.tx_migration[i][j];
                        getsuperFrame().model.tx_migration[i][i] -=
                                getsuperFrame().model.tx_migration[i][j];
                        getsuperFrame().model.tx_migration[j][j] -=
                                getsuperFrame().model.tx_migration[j][i];
                        getMatrice()[j][i].setText(
                                Float.toString(valeur));
                        getMatrice()[i][i].setText(Float.toString(
                                getsuperFrame().model.tx_migration[i][i]));
                        getMatrice()[j][j].setText(Float.toString(
                                getsuperFrame().model.tx_migration[j][j]));
                    }
                }
            }// Fin du parcours de la matrice
            
            /* Si le bouton OK est  la source de l'action, la specification
            complete du modele se termine*/
            if (e.getActionCommand().equals("OK"))
            {
                getsuperFrame().model.setNeightbourhood();
                getsuperFrame().item3.setEnabled(true);
                getsuperFrame().menu.setEnabled(true);
                
                dispose();
                
                // Ecriture des entrees dans la console du modele courant
                getsuperFrame().setEntries();
                
                try{
                getsuperFrame().saveInputFile();
            }catch(java.io.IOException eio){
                
            }
                
                return;
            }
            
            else
                return;
        }
    }
    
    
    /**
     * Extension of a general JPanel used to display
     * migration matrix
     * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
     * @version 01/03/02
     */
    private class PanelHaut extends JPanel
    {
        
        
        /**
         * Constructor of initialization of PanelHaut
         */
        private PanelHaut()
        {
            
            super();
            setLayout( new GridLayout(getsuperFrame().model.nb_pop + 1,
                    getsuperFrame().model.nb_pop + 2, 5, 5));
            
            for (int i = 0; i <= getsuperFrame().model.nb_pop; i++)
            {
                for (int j = 0; j <= getsuperFrame().model.nb_pop + 1; j++)
                {
                    
                    //Label vide du coin en haut  gauche
                    if ((i == 0 && j == 0) ||
                            j == ((GridLayout) getLayout()).getColumns()
                            - 1)
                    {
                        getColonnes()[j] = new JLabel("", JLabel.RIGHT);
                        getColonnes()[j].setPreferredSize(
                                new Dimension(40, 20));
                        add(getColonnes()[j]);
                    }
                    
                    //Labels du numero de la colonne
                    if (i == 0 && j != 0 &&
                            j < ((GridLayout) getLayout()).getColumns() - 1)
                    {
                        getColonnes()[j] = new JLabel(Integer.toString(j),
                                JLabel.CENTER);
                        getColonnes()[j].setPreferredSize(
                                new Dimension(40, 20));
                        add(getColonnes()[j]);
                    }
                    
                    //Labels du numero de la ligne
                    if (i != 0 && j == 0)
                    {
                        getLignes()[i - 1] = new JLabel(Integer.toString(i),
                                JLabel.RIGHT);
                        getLignes()[i - 1].setPreferredSize(
                                new Dimension(40, 20));
                        add(getLignes()[i - 1]);
                    }
                    
                    //Mise en place de la matrice de migration
                    if (i != 0 && j != 0 &&
                            j < ((GridLayout) getLayout()).getColumns() - 1)
                    {
                        
                        //verouillage du triangle superieur de la matrice
                        if (j >= i)
                        {
                            getMatrice()[i - 1][j - 1].setEditable(false);
                            getMatrice()[i - 1][j - 1].setBackground(
                                    getContentPane().getBackground());
                        }
                        
                        getMatrice()[i - 1][j - 1].setPreferredSize(
                                new Dimension(40, 20));
                        add(getMatrice()[i - 1][j - 1]);
                    }
                }
            }
            setSize( (int)(getLayout().preferredLayoutSize(this).width *
                    0.8), (int)
                    (getLayout().preferredLayoutSize(this).height * 0.8));
        }
    }
    
    
    /**
     * Extension of a general JPanel used to display
     * the buttons : Validate, OK, Cancel
     * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
     * @version 01/03/02
     */
    private class PanelBas extends JPanel
    {
        
        
        /**
         * Constructor of initialization of PanelBas
         */
        private PanelBas()
        {
            
            super();
            setLayout(new FlowLayout(FlowLayout.RIGHT, 10, 10));
            add(getValidate());
            add(getOK());
            add(getAnnuler());
            setSize(getLayout().preferredLayoutSize(this));
        }
    }
    
    
    /**
     * Implementation of the MigrationMatrix2 internal frame adapter
     * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
     * @version 12/12/02
     */
    private class intfram_Ad extends InternalFrameAdapter
    {
        
        
        /**
         * Procedure closing the MigrationMatrix2 internal frame
         * @param  e   a click on the top right box
         */
        public void internalFrameClosing(InternalFrameEvent e)
        {
            // Reactivation des menus Simulations
            getsuperFrame().menu.setEnabled(true);
            
            // Fermeture de la fenetre
            dispose();
        }
    }
    
    
    /**
     * Implementation of the ActionListeneter interface
     * to listen to the events of the components
     * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
     * @version 01/03/02
     */
    private class return_AL implements ActionListener
    {
        
        
        /**
         * Procedure returning to the CopiesNumbers frame
         * @param  e   a click on the Return button
         */
        public void actionPerformed(ActionEvent e)
        {
            // On reprend l'etape precedente de la procedure d'initialisation
            CopyNumbers cn =
                    new CopyNumbers(getsuperFrame());
            getsuperFrame().desktop.add(cn);
            try
            {
                cn.setSelected(true);
            }
            catch (java.beans.PropertyVetoException ve)
            {};
            
            // La procedure de saisie des taux de migration est reportee
            dispose();
            return;
        }
    }
    
    
    /**
     * Implementation of the ActionListeneter interface
     * to listen to the events of the components
     * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
     * @version 01/03/02
     */
    private class cancel_AL implements ActionListener
    {
        
        
        /**
         * Procedure closing the MigrationMarix2 frame
         * @param  e   a click on the Cancel button
         */
        public void actionPerformed(ActionEvent e)
        {
            try
            {
                moi.setClosed(true);
            }
            catch (PropertyVetoException exc)
            {};
        }
    }
    
}// Fin de la classe MigrationMatrix2



