package projet_these.ig;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyVetoException;
import java.io.File;
import java.util.Arrays;

import javax.swing.*;
import javax.swing.event.InternalFrameAdapter;
import javax.swing.event.InternalFrameEvent;

import projet_these.et.Population;
import projet_these.et.Util_Islands;

/**
 * Extension of a general internal frame used
 * to specify the parameters of the model
 * @author Yann Letrillard and Gregory Deceliere - UMR CNRS 5558 - "BBE"
 * @version 08/04/05
 */
public class OnLine extends javax.swing.JInternalFrame {
    
    // Variables declaration - do not modify
    private javax.swing.JButton B1;
    private javax.swing.JButton B2;
    private javax.swing.JButton B3;
    private javax.swing.JButton B4;
    private javax.swing.ButtonGroup BG1;
    private javax.swing.ButtonGroup BG2;
    private javax.swing.JComboBox C0;
    private javax.swing.JCheckBox CB1;
    private javax.swing.JCheckBox CB2;
    private javax.swing.JCheckBox CB3;
    private javax.swing.JCheckBox CB4;
    private javax.swing.JLabel L0;
    private javax.swing.JLabel L1;
    private javax.swing.JLabel L2;
    private javax.swing.JLabel L3;
    private javax.swing.JLabel L4;
    private javax.swing.JLabel L5;
    private javax.swing.JLabel L6;
    private javax.swing.JTextField T1;
    private javax.swing.JTextField T2;
    private javax.swing.JTextField T3;
    
    /**
     * Reference of current frame
     */
    protected OnLine moi;
    
    /**
     * Reference of main frame
     */
    protected MainFrame super_frame;
    
    /** Creates new form OnLine3
     * @param super_frame The main frame
     */
    public OnLine(MainFrame super_frame) {
        // Call of the parent constructor
        super("On Line Data Entry", false, true, false, false);
        initComponents(super_frame);
        setVisible(true);
        setLocation(10, 10);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * @param super_frame The main frame
     */
    private void initComponents(MainFrame super_frame) {
        
        java.awt.GridBagConstraints gridBagConstraints;
        
        // Setting of the parent frame
        setsuperFrame(super_frame);
        
        // Conservation d'une reference sur l'instance courante
        moi = this;
        
        // Colours uniformization with the main menu bar
        setBackground(getsuperFrame().getJMenuBar().getBackground());
        
        // Closing managment of the window by the checked box
        addInternalFrameListener(new intfram_Ad());
        
        getContentPane().setLayout(new java.awt.GridBagLayout());
        
        setClosable(true);
        setTitle("Online data entry");
        
        BG1 = new javax.swing.ButtonGroup();
        BG2 = new javax.swing.ButtonGroup();
        L0 = new javax.swing.JLabel();
        C0 = new javax.swing.JComboBox();
        L1 = new javax.swing.JLabel();
        T1 = new javax.swing.JTextField("" + this.getsuperFrame().model.tps);
        T1.setToolTipText("Enter an integer greater than 2");
        L2 = new javax.swing.JLabel();
        T2 = new javax.swing.JTextField("" + this.getsuperFrame().model.nb_pop);
        T2.setToolTipText("Enter an integer greater than 1");
        L3 = new javax.swing.JLabel();
        CB1 = new javax.swing.JCheckBox("Yes",
                (getsuperFrame().model.rep_tailles.
                equals("H")));
        CB1.addActionListener(new sizeH_AL());
        CB2 = new javax.swing.JCheckBox("No",
                (getsuperFrame().model.rep_tailles.
                equals("NH")));
        CB2.addActionListener(new sizeNH_AL());
        L4 = new javax.swing.JLabel();
        CB3 = new javax.swing.JCheckBox("Yes",
                (getsuperFrame().model.rep_tx.equals(
                "H")));
        CB3.addActionListener(new txH_AL());
        CB4 = new javax.swing.JCheckBox("No",
                (getsuperFrame().model.rep_tx.equals(
                "NH")));
        CB4.addActionListener(new txNH_AL());
        L5 = new javax.swing.JLabel();
        L6 = new javax.swing.JLabel();
        //T3 = new javax.swing.JTextField("" + this.getsuperFrame().model.nomFic2);
        T3 = new javax.swing.JTextField("Default");
        T3.setToolTipText("Enter a name for this simulation that will be given to the output files of TESD");
        B1 = new javax.swing.JButton();
        B1.addActionListener(new ok_AL());
        B2 = new javax.swing.JButton();
        B2.addActionListener(new cancel_AL());
        B4 = new javax.swing.JButton();
        B4.addActionListener(new chooseDir_AL());
        B3 = new javax.swing.JButton();
        B3.addActionListener(new MolRates_AL());
        BG1.add(CB1);
        BG1.add(CB2);
        BG2.add(CB3);
        BG2.add(CB4);
        
        L0.setFont(new java.awt.Font("Dialog", 0, 12));
        L0.setText("Choose your model:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(20, 20, 0, 0);
        getContentPane().add(L0, gridBagConstraints);
        
        C0.setFont(new java.awt.Font("Dialog", 1, 12));
        C0.setModel(new javax.swing.DefaultComboBoxModel(new String[] {"NM",
                "(LB -- soon)", "(AC1 -- soon)"}));
                C0.setSelectedItem("" + this.getsuperFrame().model.conta_mod);
                gridBagConstraints = new java.awt.GridBagConstraints();
                gridBagConstraints.gridx = 1;
                gridBagConstraints.gridy = 0;
                gridBagConstraints.gridwidth = 2;
                gridBagConstraints.insets = new java.awt.Insets(20, 0, 0, 0);
                getContentPane().add(C0, gridBagConstraints);
                
                L1.setFont(new java.awt.Font("Dialog", 0, 12));
                L1.setText("How many generations do you wish to simulate?");
                gridBagConstraints = new java.awt.GridBagConstraints();
                gridBagConstraints.gridx = 0;
                gridBagConstraints.gridy = 1;
                gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
                gridBagConstraints.insets = new java.awt.Insets(5, 20, 0, 0);
                getContentPane().add(L1, gridBagConstraints);
                
                gridBagConstraints = new java.awt.GridBagConstraints();
                gridBagConstraints.gridx = 1;
                gridBagConstraints.gridy = 1;
                gridBagConstraints.gridwidth = 2;
                gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
                gridBagConstraints.insets = new java.awt.Insets(5, 10, 0, 20);
                getContentPane().add(T1, gridBagConstraints);
                
                L2.setFont(new java.awt.Font("Dialog", 0, 12));
                L2.setText("How many populations do you wish to simulate?");
                gridBagConstraints = new java.awt.GridBagConstraints();
                gridBagConstraints.gridx = 0;
                gridBagConstraints.gridy = 2;
                gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
                gridBagConstraints.insets = new java.awt.Insets(5, 20, 0, 0);
                getContentPane().add(L2, gridBagConstraints);
                
                gridBagConstraints = new java.awt.GridBagConstraints();
                gridBagConstraints.gridx = 1;
                gridBagConstraints.gridy = 2;
                gridBagConstraints.gridwidth = 2;
                gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
                gridBagConstraints.insets = new java.awt.Insets(5, 10, 0, 20);
                getContentPane().add(T2, gridBagConstraints);
                
                L3.setFont(new java.awt.Font("Dialog", 0, 12));
                L3.setText("Homogeneous population sizes ?");
                gridBagConstraints = new java.awt.GridBagConstraints();
                gridBagConstraints.gridx = 0;
                gridBagConstraints.gridy = 3;
                gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
                gridBagConstraints.insets = new java.awt.Insets(5, 20, 0, 0);
                getContentPane().add(L3, gridBagConstraints);
                
                gridBagConstraints = new java.awt.GridBagConstraints();
                gridBagConstraints.gridx = 1;
                gridBagConstraints.gridy = 3;
                gridBagConstraints.insets = new java.awt.Insets(5, 10, 0, 0);
                getContentPane().add(CB1, gridBagConstraints);
                
                gridBagConstraints = new java.awt.GridBagConstraints();
                gridBagConstraints.gridx = 2;
                gridBagConstraints.gridy = 3;
                gridBagConstraints.insets = new java.awt.Insets(5, 10, 0, 20);
                getContentPane().add(CB2, gridBagConstraints);
                
                L4.setFont(new java.awt.Font("Dialog", 0, 12));
                L4.setText("Homogeneous migration rates betwen populations ?");
                gridBagConstraints = new java.awt.GridBagConstraints();
                gridBagConstraints.gridx = 0;
                gridBagConstraints.gridy = 4;
                gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
                gridBagConstraints.insets = new java.awt.Insets(5, 20, 0, 0);
                getContentPane().add(L4, gridBagConstraints);
                
                gridBagConstraints = new java.awt.GridBagConstraints();
                gridBagConstraints.gridx = 1;
                gridBagConstraints.gridy = 4;
                gridBagConstraints.insets = new java.awt.Insets(5, 10, 0, 0);
                getContentPane().add(CB3, gridBagConstraints);
                
                gridBagConstraints = new java.awt.GridBagConstraints();
                gridBagConstraints.gridx = 2;
                gridBagConstraints.gridy = 4;
                gridBagConstraints.insets = new java.awt.Insets(5, 10, 0, 20);
                getContentPane().add(CB4, gridBagConstraints);
                
                L5.setFont(new java.awt.Font("Dialog", 0, 12));
                L5.setText("Simulation name:");
                gridBagConstraints = new java.awt.GridBagConstraints();
                gridBagConstraints.gridx = 0;
                gridBagConstraints.gridy = 5;
                gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
                gridBagConstraints.insets = new java.awt.Insets(5, 20, 0, 0);
                getContentPane().add(L5, gridBagConstraints);
                
                gridBagConstraints = new java.awt.GridBagConstraints();
                gridBagConstraints.gridx = 1;
                gridBagConstraints.gridy = 5;
                gridBagConstraints.gridwidth = 2;
                gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
                gridBagConstraints.insets = new java.awt.Insets(5, 10, 0, 20);
                getContentPane().add(T3, gridBagConstraints);
                
                L6.setFont(new java.awt.Font("Dialog", 0, 12));
                L6.setText("Change directory ? (" + super_frame.getCurrentPath() + ")");
                gridBagConstraints = new java.awt.GridBagConstraints();
                gridBagConstraints.gridx = 0;
                gridBagConstraints.gridy = 6;
                gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
                gridBagConstraints.insets = new java.awt.Insets(5, 20, 0, 0);
                getContentPane().add(L6, gridBagConstraints);
                
                B4.setFont(new java.awt.Font("Dialog", 0, 12));
                B4.setText("Change dir");
                gridBagConstraints.gridx = 1;
                gridBagConstraints.gridy = 6;
                gridBagConstraints.gridwidth = 2;
                gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
                gridBagConstraints.insets = new java.awt.Insets(5, 10, 0, 20);
                getContentPane().add(B4, gridBagConstraints);
                
                B1.setFont(new java.awt.Font("Dialog", 0, 12));
                B1.setText("OK");
                gridBagConstraints = new java.awt.GridBagConstraints();
                gridBagConstraints.gridx = 1;
                gridBagConstraints.gridy = 7;
                gridBagConstraints.insets = new java.awt.Insets(5, 10, 20, 0);
                getContentPane().add(B1, gridBagConstraints);
                
                B2.setFont(new java.awt.Font("Dialog", 0, 12));
                B2.setText("Cancel");
                gridBagConstraints = new java.awt.GridBagConstraints();
                gridBagConstraints.gridx = 2;
                gridBagConstraints.gridy = 7;
                gridBagConstraints.insets = new java.awt.Insets(5, 10, 20, 20);
                getContentPane().add(B2, gridBagConstraints);
                
                B3.setFont(new java.awt.Font("Dialog", 0, 12));
                B3.setText("Molecular rates");
                gridBagConstraints = new java.awt.GridBagConstraints();
                gridBagConstraints.gridx = 0;
                gridBagConstraints.gridy = 7;
                gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
                gridBagConstraints.insets = new java.awt.Insets(5, 20, 20, 10);
                getContentPane().add(B3, gridBagConstraints);
                
                pack();
    }
    
    /**
     * Access function to the main frame
     * @return MainFrame the instance of the main frame
     */
    private MainFrame getsuperFrame() {
        
        return super_frame;
    }
    
    
    /**
     * Procedure setting the reference to main frame
     * @param sf MainFrame the instance of main frame
     */
    private void setsuperFrame(MainFrame sf) {
        
        super_frame = sf;
    }
    
    
    /**
     * Implementation of the ActionListeneter interface
     * to listen to the events of the components
     * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
     * @version 01/03/02
     */
    private class MolRates_AL implements ActionListener {
        /**
         * Error message
         */
        private String message = "";
        
        /**
         * Procedure setting the current model nb_pop and nomFic2
         * @param  e   a click on the OK button
         */
        public void actionPerformed(ActionEvent e) {
            
            MolecularRates molrates = new MolecularRates(getsuperFrame());
            int molratesX = (int) OnLine.this.getsuperFrame().getBounds().getCenterX()
            - (molrates.getWidth()/2);
            int molratesY = (int) OnLine.this.getsuperFrame().getBounds().getCenterY()
            - (molrates.getHeight()/2);
            molrates.setLocation(new java.awt.Point(molratesX, molratesY));
            molrates.setVisible(true);
        }
    }
    private class chooseDir_AL implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            JFileChooser chooser = new JFileChooser();
            if(super_frame.getCurrentPath() != null)
                chooser.setCurrentDirectory(new File(super_frame.getCurrentPath()));
            chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
            chooser.setApproveButtonText("Ok");
            chooser.setDialogTitle("Choose a directory to save the .para file");
            int return_value = chooser.showDialog(super_frame, null);
            if (return_value == chooser.APPROVE_OPTION) {
                super_frame.setCurrentPath(chooser.getSelectedFile().toString());
            }
            L6.setText("Change directory ? (" + super_frame.getCurrentPath() + ")");
            moi.pack();
        }
    }
    
    /**
     * Implementation of the ActionListeneter interface
     * to listen to the events of the components
     * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
     * @version 01/03/02
     */
    private class ok_AL implements ActionListener {
        /**
         * Error message
         */
        private String message = "";
        
        /**
         * Procedure setting the current model nb_pop and nomFic2
         * @param  e   a click on the OK button
         */
        public void actionPerformed(ActionEvent e) {
            
            //Initialization of contamination model
            if (C0.getSelectedItem().equals("NM") ||
                    C0.getSelectedItem().equals("LB") ||
                    C0.getSelectedItem().equals("AC1"))
                getsuperFrame().model.conta_mod = (String) C0.getSelectedItem();
            else
                getsuperFrame().model.conta_mod = "NM";
            
            //Capture of generation number with error managment
            if (!Util_Islands.isNumeric(T1.getText()) ||
                    T1.getText().equals("") ||
                    !(Integer.valueOf(T1.getText()).intValue() >= 1)) {
                message =
                        "Error of data entry\n" +
                        "Field: Data entry of the generations number\n" +
                        "Enter a strictly positive integer";
                JOptionPane.showInternalMessageDialog(
                        getsuperFrame().getContentPane(), message, "",
                        JOptionPane.ERROR_MESSAGE);
                return;
            } else {
                getsuperFrame().model.tps =
                        Integer.valueOf(T1.getText()).intValue();
            }
            
            //Capture of population number with error managment
            if (!Util_Islands.isNumeric(T2.getText()) ||
                    T2.getText().equals("") ||
                    !(Integer.valueOf(T2.getText()).intValue() > 1)) {
                message =
                        "Error of data entry\n" +
                        "Field: Data entry of the populations number\n" +
                        "Enter an integer value higher than one";
                JOptionPane.showInternalMessageDialog(getsuperFrame().
                        getContentPane(), message,
                        "",
                        JOptionPane.ERROR_MESSAGE);
                return;
            } else if (Integer.valueOf(T2.getText()).intValue() !=
                    getsuperFrame().model.nb_pop) {
                getsuperFrame().model.nb_pop =
                        Integer.valueOf(T2.getText()).intValue();
                getsuperFrame().model.N =
                        new int[getsuperFrame().model.nb_pop];
                getsuperFrame().model.iles =
                        new Population[getsuperFrame().model.nb_pop];
                getsuperFrame().model.nbcop =
                        new float[getsuperFrame().model.nb_pop];
                Arrays.fill(getsuperFrame().model.nbcop, 0f);
            }
            
            //Capture of output file name with error managment
            if (T3.getText().equals("")) {
                message = "Error of data entry\n" + "Field: Output file\n" +
                        "Enter the simulation name";
                JOptionPane.showInternalMessageDialog(getsuperFrame().
                        getContentPane(), message,
                        "",
                        JOptionPane.ERROR_MESSAGE);
                return;
            } else {
                int iii = 2;
                String base_name = super_frame.getCurrentPath() + System.getProperty("file.separator") + T3.getText();
                File mea_file = new File(base_name + ".simul1.mea");
                File para_file = new File(base_name + ".para");
                while(mea_file.exists() || para_file.exists()){
                        mea_file = new File(base_name + "." + iii + ".simul1.mea");
                        para_file = new File(base_name + "." + iii + ".para");
                        iii++;
                }
                getsuperFrame().model.nomFic2 = base_name + "." + Integer.toString(iii);
                getsuperFrame().model.nomFic1 = base_name + "." + Integer.toString(iii);
            }

            
            //Capture of size homogeneity parameter with error managment
            if (!(getsuperFrame().model.rep_tailles.equals("H")) &&
                    !(getsuperFrame().model.rep_tailles.equals("NH"))) {
                message =
                        "Error of data entry\n" + "Field: Populations Sizes\n" +
                        "Check the suitable box";
                JOptionPane.showInternalMessageDialog(getsuperFrame().
                        getContentPane(), message,
                        "",
                        JOptionPane.ERROR_MESSAGE);
                return;
            }
            
            //Capture of stream homogeneity parameter with error managment
            if (!(getsuperFrame().model.rep_tx.equals("H")) &&
                    !(getsuperFrame().model.rep_tx.equals("NH"))) {
                message =
                        "Error of data entry\n" + "Field: Migration Entry\n" +
                        "Check the suitable box";
                JOptionPane.showInternalMessageDialog(getsuperFrame().
                        getContentPane(), message,
                        "",
                        JOptionPane.ERROR_MESSAGE);
                return;
            }
            
            //Update of entries, opening of the size defining window, and current windw closing
            if (getsuperFrame().entries != null) {
                getsuperFrame().entries.upDate();
            }
            PopulationSizes ps = new PopulationSizes(getsuperFrame());
            getsuperFrame().desktop.add(ps);
            try {
                ps.setSelected(true);
            } catch (java.beans.PropertyVetoException ve) {}
            ;
            
            dispose();
            return;
        }
    }
    
    
    /**
     * Implementation of the ActionListeneter interface
     * to listen to the events of the components
     * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
     * @version 01/03/02
     */
    private class cancel_AL implements ActionListener {
        
        
        /**
         * Procedure closing the OnLine frame
         * @param  e   a click on the Cancel button
         */
        public void actionPerformed(ActionEvent e) {
            try {
                moi.setClosed(true);
            } catch (PropertyVetoException exc) {}
            ;
        }
    }
    
    
    /**
     * Implementation of the OnLine internal frame adapter
     * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
     * @version 12/12/02
     */
    private class intfram_Ad extends InternalFrameAdapter {
        
        
        /**
         * Procedure closing the OnLine internal frame
         * @param  e   a click on the top right box
         */
        public void internalFrameClosing(InternalFrameEvent e) {
            
            // Reactivation of Simulations menu
            getsuperFrame().menu.setEnabled(true);
            
            // Closing of window
            dispose();
        }
    }
    
    
    /**
     * Implementation of SizeH check box listener
     * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
     * @version 12/12/02
     */
    private class sizeH_AL implements ActionListener {
        
        /**
         * Procedure setting the current model rep_taille
         * on H
         * @param  e   a click on the check box
         */
        public void actionPerformed(ActionEvent e) {
            getsuperFrame().model.rep_tailles = "H";
        }
    }
    
    
    /**
     * Implementation of SizeNH check box listener
     * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
     * @version 12/12/02
     */
    private class sizeNH_AL implements ActionListener {
        
        /**
         * Procedure setting the current model rep_taille
         * on NH
         * @param  e   a click on the check box
         */
        public void actionPerformed(ActionEvent e) {
            getsuperFrame().model.rep_tailles = "NH";
        }
    }
    
    
    /**
     * Implementation of txH check box listener
     * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
     * @version 12/12/02
     */
    private class txH_AL implements ActionListener {
        
        /**
         * Procedure setting the current model rep_tx
         * on H
         * @param  e   a click on the check box
         */
        public void actionPerformed(ActionEvent e) {
            getsuperFrame().model.rep_tx = "H";
        }
    }
    
    
    /**
     * Implementation of txNH check box listener
     * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
     * @version 12/12/02
     */
    private class txNH_AL implements ActionListener {
        
        /**
         * Procedure setting the current model rep_tx
         * on NH
         * @param  e   a click on the check box
         */
        public void actionPerformed(ActionEvent e) {
            getsuperFrame().model.rep_tx = "NH";
        }
    }
}
